
#include "core.h"

APP_EXTENSION const Extensions[NumExt]={
//	func name #, 				help string # 				index
	{OO_FIRST_APP_STRING + XR_ExtFunc,	OO_FIRST_APP_STRING + XR_st_ExtFunc,	0},
#ifdef UseHelp
	{OO_FIRST_APP_STRING + XR_help, 	OO_FIRST_APP_STRING + XR_st_help,	1},
#endif
};

APP_EXT_ENTRY const ExtTypes[NumExt]={
//	&Function(),	type
	{TIGCC_data,	APP_EXT_FUNCTION},
#ifdef UseHelp
	{Help,		APP_EXT_PROGRAM },
#endif
};


#ifdef UseHelp
FRAME(MainFrame, OO_SYSTEM_FRAME, 0, OO_APP_FLAGS, 8)
#else
FRAME(MainFrame, OO_SYSTEM_FRAME, 0, OO_APP_FLAGS, 6)
#endif
	ATTR(OO_APP_FLAGS, 	 0)		//Application data
	ATTR(OO_APP_NAME, 	 "ExtFunc")
	ATTR(OO_APP_TOK_NAME, 	 "extfunc")
	
	ATTR(OO_APP_EXT_COUNT, 	 NumExt)	//TI-BASIC extensions
	ATTR(OO_APP_EXTENSIONS,  Extensions)
	ATTR(OO_APP_EXT_ENTRIES, ExtTypes)

#ifdef UseHelp
	ATTR(OO_APP_EXT_HELP,	 CatalogHelp)	//Help & About
	ATTR(OO_APP_ABOUT,	 About)
#endif
ENDFRAME

STRING_FRAME(StringFrame, OO_SYSTEM_FRAME, &MainFrame, OO_FIRST_STRING + OO_FIRST_APP_STRING, NUM_XR_STRINGS)
//App ext extension help strings

	"ExtFunc",														//XR_ExtFunc
	"Extended BASIC functions",									//XR_st_ExtFunc
#ifdef UseHelp
	"ExtFunc(\"return\",function #,[arg1],...)",
	"Help",
	"Help(fn #)",
	"Provides help on one function.\nhelp(function #)",
#endif	
//Application Strings   
	"ExtFunc",			//XR_ShortAppName
	"ExtFunc v" APP_VERSION,	//XR_LongAppName
	"extfunc.",			//XR_ExtFunc_EXT	this string must be consistent with the OO_APP_TOK_NAME frame entry
	"extfunc(",			//XR_ExtFunc_MINIMAL	this string must be consistent with the OO_APP_TOK_NAME frame entry
	"\0extfunc",			//XR_ExtFunc_TOK	this string must be consistent with the OO_APP_TOK_NAME frame entry
#ifdef UseHelp
	"Returns current version without decimal",
	"\"txt\"\nplace text in status line",
	"\"txt\", x, y, [size = {0,1,2}], [drawmode]\ndisplay text of any size",
	"x, y, [drawmode]\npixel on/off; return previous",
	"x or {xlist}, y or {ylist}, {bytelist}\ndraws a 8-pixel-wide sprite at one or more locations",
	"x\nset busy indicator: 0=off, 1=BUSY, 2=PAUSE",
	"turn off calculator",
	"\"title\", \"txt\", btn, btn\nmessage dialog",
	"\"file\"\nget file's HANDLE number (can also be \"folder\\\")",
	"\"file\", [set_flags]\nget file or folder's flags (locked, archived,...see SymFlags in TIGCC help)",
	"handle\nreturns {typebyte, handlesize, varsize-2}",
	"handle, pos\nreads byte [pos] in handle (starts at 1)",
	"handle, pos, byte\nwrites to byte [pos] in handle",
	"\"name\", size\ncreates blank file with given size (write with #12). returns handle",
	"battery state: 7=full",
	"getKey with wait (the C version: keys may be different)",
	"errnum\nget text of an error message",
	"\"folder\"\nlist of contents of a folder",
	"\"command\"\nmake home-screen entry with the contents",
	"[byte]\nsend byte to link port OR read first byte in buffer",
	"contrast, [APDTimer in sec/20]\ncontrast={0:no change,1:up,2:down}. APD default is 5 minutes.",
	"keycode\ninsert key into key buffer (use codes from #15, not getkey())",
	"[string]\nclipboard insert or read",
	"[check], \"title\", [x], [y], [[\"item1\", parent1][\"item2\",parent2][...]]\n\nPopup menu with submenus: parent=0 for main, parent=item number for submenu. Returns row selected. If check = true, then items are checked and a list is returned",
	"\"title\", [x], [y]\nSame as #23, with all variables and folders on calc. Name is returned",
	"handle\nSame as string() function from BASIC, but works on functions & programs (and home screen history)",
	"number\nreturns handles of homescreen entry as lists {entry, answer, FIFO_NODE}",
	"address, [size]\nReads memory from address given\nif size=0, read string",
	"address, value, [size]\nwrites to address (size = 1,2,4)\nstring also accepted",
	"handle, [lockstate]\nreturns address of handle. if called with lockstate, (un)locks handle",
	"test, expression, [outexpr]\nPreforms regular expression processing on test",
	"\"command\"\nSends command to home screen and executes",
	"num, [romcall]\nRetrieve handle or address\n0 get romcall address\n1 Home folder\n2 First app\n3 EStack",
#endif
ENDFRAME

pFrame FramePtr = (pFrame)&StringFrame;  /* Must be the first global variable declared! */
