| Copyright (C) 2003  Daniel De Graaf
| Assembly Source File
.data|contains
	.global ExecFunc
	.global CheckInt
	.global Int2
	.global OneMinus
	.global OneInt
	.global FillBufWithLocalName
	| Function offset table
	| Functions 7 and 14

/*
 HANDLE ExecFunc(ESI) regparm
  call the function specified by the estack
  setup TRY...ONERR block

 long CheckInt(CESI,long,long,long) STRANGE
  wrapper for GetValue to return a default value if one is not given
  
 HANDLE OneInt(WORD) stkparm
  setup a TI-BASIC variable that contains the integer value
  returns handle, 0 if none
 
 void Int2(WORD, char*) regparm(d0, const a0)
  write RPN of (1+integer) to pointer
  
 void OneMinus(char*) regparm(const a0)
  write RPN of "<whatever> - 1" to pointer
 
 string FillBufWithLocalName(char*, string, string) regparm(a2,a3,a4)
  fills buffer a2 with full name of local variable in a3
  a3 = "\localv"  If not in program, return to current folder
*/
	
.macro Func name
	.word \name-functions
	.set NumFunc,NumFunc+1
.endm
	.set NumFunc,-1

functions:
/*0*/	Func version
	Func disp
	Func dispTxt
	Func drawPxl
	Func sprite
/*5*/	Func busy
	Func power
	Func message
	Func GetHandle
	Func Flags
/*10*/	Func info
	Func read
	Func write
	Func create
	Func batt
/*15*/	Func getKey
	Func ErrTxt
	Func dir
	Func HomeScr
	Func linkRW
/*20*/	Func SysSet
	Func pushKey
	Func clipB
	Func menu
	Func VarMenu
/*25*/	Func detokenize
	Func GetHSHandle
	Func ReadMem
	Func WriteMem
	Func GetAddrHand
/*30*/	Func RegExpr
	Func HomeExec
	Func GetSysVal


ExecFunc:
|Set up TRY block in ASM
	lea (sp,-60),sp
	pea NumFunc.w		|arguments for GetValue
	pea 0.w
	pea (a0)
	pea 12(sp)		| &(60-byte ERROR_FRAME)
	.word 0xF954		|ER_catch(stack data)
	tst.w d0
	jbne ExecFuncRet0	|We have an error...
	addq.l #4, sp		|remove ERROR_FRAME*
|TRY block done

|Get function number
	.word 0xFACB 		|GetValue(a0,0,NumFunc)
	move.w d0, d3		|value to d3
	.word 0xF90A 		|next_expression_index
|Get address
	lea functions, a1
	add.w d3,d3		|functions are WORD, not BYTE
	move.w (a1,d3.w),d0	|d0 = offset from functions
|run
	jbsr (a1,d0.w)		|rts goes back to _main
	move.w d0,d3		|save result

	.word 0xF955 		|ER_success
	move.w d3,d0
	lea (72, sp) ,sp	|restore stack
|restore clobbered registers
	move.l (sp,-40), a2	|ERROR_FRAME data contains register
	move.l (sp,-60), d3	|values that are overwritten
	rts

ExecFuncRet0:
	lea (sp,76),sp
Ret0:
	clr.w d0
	rts

FillBufWithLocalName:
	clr.w -(sp)
	clr.l -(sp)
	.word 0xF86C		| SymFindFirst(0,0);
	addq.l #6,sp
	cmp.b #'0', (a0)	| sym->name[0] == '0'
	jbne FBWLN_exit 
FBWLN_loop:
	cmp.b #'0',14(a0)	| sym[1].name == '0'
	jbne FBWLN_found
	lea (14,a0), a0		| sym = &sym[1]
	jbra FBWLN_loop
FBWLN_found:
	clr.b (a2)		| buffer[0]=0;
	pea 4.w
	pea (a0)
	pea 1(a2)
	.word 0xFA6A		| memcpy(buffer+1, sym, 4);
	pea (a3)
	pea 5(a2)
	.word 0xFA6C		| strcpy(buffer+5, name);
	pea (a3)
	.word 0xFA7E		| strlen(name)
	lea (5,a2,d0.w),a0	| return 5+buffer+d0
	lea (24,sp),sp		| 6 pea's
	rts
FBWLN_exit:
	move.l a4,a0		| No local folders,
	rts

CheckInt:
|	trap #4
	move.l (sp), a0   |args
	cmp.b #31, (a0)   |POSINT_TAG
	jbeq CheckIntJmp
	cmp.b #35, (a0)   |FLOAT_TAG
	jbne CheckIntExit
CheckIntJmp:
	.word 0xFACB      |GetValue
	move.l d0, 12(sp) |change 'default' value
	.word 0xF90A      |next_expression_index
CheckIntExit:
	move.l 12(sp), d0 |return default value
	lea (16,sp), sp   |move our stack back
	rts               |return address 

OneInt:
	pea 10.w
	.word 0xF890     |HeapAlloc(10)
	tst.w d0
	jbeq Ret0
	move.w d0,-(sp)  |save handle
	.word 0xF896     |HeapDeref
	move.w 10(sp),d0 |argument
	move.w #8,(a0)+  |data is 8 bytes
	jbsr Int2
	move.w (sp),d0   |return handle
	addq.l #6,  sp
	addq.l #4,  a0

OneMinus:
	move.b #1,    (a0) 	|Move.b is needed because it could be an odd address
	move.b #1,   1(a0)
	move.b #31,  2(a0)	| POSINT_TAG
	move.b #-115,3(a0)	| SUB_TAG
	rts

Int2:
	addq.w #1,d0
	move.b d0,  (a0)
	lsr.w #8,d0		| d0 /= 256
	move.b d0, 1(a0)
	move.b #2, 2(a0)
	move.b #31,3(a0)	| POSINT_TAG
	rts

power:
	trap #4
	clr.w d0
	rts

batt:
	move.w #0x700,d0	|OSSetSR(0x700);
	trap #1
	.word 0xF95E		|AB_getGateArrayVersion()
	subq.w #1,d0
	move.w d0,d2
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
	tst.w   d2  		| jump for HW1
	beq     bat_h1_1
	lea     0x70001D,a0
	move.b  (a0),d0
	ori.b   #9,d0
	move.b  d0,(a0)
bat_h1_1:
	moveq   #6,d1
	lea     0x600018,a1
bat_loop:
	bsr.s   bat_ini	| this initialization lacked in previous versions
	move.w  d1,d0
	lsl.w   #7,d0
	move.w  d0,(a1)
	moveq   #0x6e,d0
bat_test:
	btst.b  #2,-0x18(a1)
	dbeq    d0,bat_test
	beq.s   bat_quit
	dbf     d1,bat_loop
bat_quit:
	neg.w   d1
	addq.w  #6,d1
	tst.w   d2
	beq.s   bat_h1_2	| jump for HW1
	and.b   #0xF7,(a0)
	bsr.s   bat_ini
	andi.b  #0xF6,(a0)
bat_h1_2:
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
	move.w d1,-(sp)
	clr.w d0
	trap #1
	jbsr OneInt
	addq.w #2, sp
	rts
/*
	move.w d3,-(sp)
	move.w d1,d3
	clr.w d0		|OSSetSR(0);
	trap #1
	pea 5.w 		|d0 = HeapAlloc(5);
	.word 0xF890
	addq.l #4,sp		|stack == (5 0)
	tst.w d0		|ERR(!d0);
	jbeq battNoMem  	|d0 is 0, so no need to clear it before rts
	move.w d0,-(sp)		|d0 pushed to stack ---+
	.word 0xF896		|a0 = HeapDeref(d0);   |
	move.w #3,(a0)+ 	|*a0 = 3;              |
	move.b d3,(a0)+ 	|a0[2] = d3;           |
	move.b #1,(a0)+ 	|a0[3] = 1;            |
	move.b #31,(a0) 	|a0[4] = POSINT_TAG    |
	move.w (sp)+,d0 	|return handle;    <<--+
 battNoMem:
	move.w (sp)+,d3
	rts
*/
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
bat_ini:
	move.w  #0x380,(a1)
	moveq   #52,d0
bat_wait:
	btst.b  #2,-0x18(a1)
	dbeq    d0,bat_wait
	rts
/*

#define Int(value,p,d) do {\
	WORD v = value+1; \
	d[p] = v%256; \
	d[p+1] = v/256; \
	d[p+2] = 2; \
	d[p+3] = POSINT_TAG; \
} while (0)
#define OneMinus(p,d) do { \
	d[p]=1;\
	d[p+1]=1;\
	d[p+2]=POSINT_TAG;\
	d[p+3]=SUB_TAG;\
} while (0)

string FillBufWithLocalName(char* buffer asm("a2"), string name asm("a3")) {
	WORD tmp;
	buffer[0]=0;
	SYM_ENTRY *sym=SymFindFirst(0,0);
	if (sym->name[0] == '0') { //local folders exist
		for(tmp=1; sym[tmp].name[0] == '0'; tmp++);
		memcpy(buffer+1, sym[tmp-1].name, 4); // localfoldername (len=4)
		tmp=strlen(name);
		memcpy(buffer+5, name, tmp+1); // should be '\x'
		return buffer+5+tmp;
	}
	return name+1;
}

Func batt(FuncArgs) {
	DWORD* rombase = ROM_base;
	DWORD hwpb = rombase[65];
	OSSetSR(0x700);
	WORD level = BatteryState(((WORD)(hwpb - (DWORD)rombase  < 0x10000 &&
	     *(WORD*)hwpb > 22 ? *(DWORD *)(hwpb + 22) : 1) - 1L));
	OSSetSR(0);
	return OneInt(level);
}

-------------------------------------------------------------------
|Set up TRY block in ASM
	lea (sp,-60),sp
	pea NumFunc.w		|arguments for GetValue
	pea 0.w
	pea (a0)
	pea 12(sp)		| &(60-byte ERROR_FRAME)
	.word 0xF954		|ER_catch(stack data)
	tst.w d0
	jbne FixStackRet0	|We have an error...
	addq.l #4, sp		|remove ERROR_FRAME*
|Get function number
	.word 0xFACB 		|GetValue
	move.w d0, d3		|value to d3
	.word 0xF90A 		|next_expression_index
	move.l a0, a2		|save args
	.word 0xF955 		|ER_success
	lea (72, sp) ,sp	|restore stack
	move.l a2, a0		|restore args
|Get address
	lea functions, a1
	add.w d3,d3		|functions are WORD, not BYTE
	move.w (a1,d3.w),d0	|d0 = offset from functions

|restore clobbered registers
	move.l (sp,-40), a2	|ERROR_FRAME data contains register
	move.l (sp,-60), d3	|values that are overwritten
|run
	jbra (a1,d0.w)		|rts goes back to _main
-------------------------------------------------------------------
	cmp.b #31,(a0) | POSINT_TAG = 31, comparing to *args
	jbne Ret0Lbl    | return 0;

	moveq.l #0, d0
	move.b -(a0),d1 |length of integer
	tst.b d1
	jbeq NumInD0    | function zero

	cmp.b #1, d1
	jbne Ret0Lbl    | number >255
	
	move.b -(a0),d0
	cmp.w #NumFunc, d0
	jbgt Ret0Lbl    | calling nonexistant function
 NumInD0:
	subq.w #1, a0
-------------------------------------------------------------------
|This function accesses the handle table itself, not the TI function
|**But, is larger than the F-line call and requires code writeback**

|init by:
	move.l 0xC8,a0
	move.l (0x441*4,a0),d0
	lea HeapTable, a0
	move.l d0, (a0)

 HeapDeref: 
	tst.l d0
	jbeq NoHDRZero           | can't HDR zero
	lsl.l #2,d0             | multiply argument by 4

	.word 0x207C |opcode for  move.l #XXXX,a0 where XXXX is next 4 bytes
 HeapTable: |address of the heap table goes here at start of program
	.long 0
	move.l (a0,d0.l),a0   | load address from table
	rts
 NoHDRZero:
	move.l d0,a0 |shorter than move #0
	rts
*/