// Copyright (C) 2003  Daniel De Graaf

///////////////////////
//   TIGCC library   //
///////////////////////

#define USE_TI89
#define USE_TI92PLUS
#define USE_V200

#define USE_FLINE_ROM_CALLS
#define USE_INTERNAL_FLINE_EMULATOR

#define NO_EXIT_SUPPORT
#define NO_CALC_DETECT
#define MIN_AMS 1000
#define NO_AMS_CHECK 

#ifndef Flash
#define SET_FILE_IN_USE_BIT
#define RETURN_VALUE
#endif

#include <tigcclib.h>

//////////////////////////////
// Templates for a function //
//////////////////////////////
typedef const char* string;
typedef unsigned short Func;
#define FuncArgs ESI args asm("a0") __attribute__ ((unused))

////////////////////////
//  asm.h prototypes  //
////////////////////////

HANDLE ExecFunc(ESI asm("a0"));
HANDLE OneInt(short);
string FillBufWithLocalName(char* asm("a2"), string asm("a3"), string asm("a4"));

////////////////
//   Macros   //
////////////////

#define GetInt(l,u) ({ long __t=GetValue(args,l,u); args=next_expression_index(args); __t;})
#define GetLastInt(l,u) GetValue(args,l,u)
#define OptInt(l,u,d) ({      \
	register long __t asm("d0"); \
	register void* __a asm("a0"); \
	asm("pea 0f(pc)\n"   \
	    "pea " #d ".w\n"  \
	    "pea " #u ".w\n"   \
	    "pea " #l ".w\n"    \
	    "pea (%1)\n"         \
	    "jbra CheckInt\n 0:"  \
		: "=d" (__t), "=a" (__a) \
		: "1" (args)            \
		: "a1","d1","d2");     \
		args = __a; __t;})

#define IsInt (*args == POSINT_TAG || *args == FLOAT_TAG)

#define ERR(x) if (x) return 0

//create new handle and pointer, fill

//For error checking, add HeapShuffle() before HeapAlloc

#define DefData(size) \
	HANDLE d_h = HeapAlloc((size)+2); ERR(!d_h); \
	BYTE* data = HeapDeref(d_h);                  \
	*((WORD*)(data)) = (size); data += 2

#define IntData(x,y) ({ \
	register short __x asm("d0")=(x);           \
	register void* __y asm("a0")=data + (y);     \
	asm("jbsr Int2 " :: "d" (__x), "a" (__y));})

#define EndData(x) ({ \
	register void* __x asm("a0")=data + (x);    \
	asm("jbsr OneMinus" :: "a" (__x));})
